#ifndef STRING_H
#define STRING_H 1

typedef struct String8 String8;
struct String8
{
  u8 *str;
  u64 length;
};

internal String8 str8_initialize(u8 *cstring, u64 length);
#define str8_lit(cstring)                                                      \
  str8_initialize((u8*)(cstring), sizeof(cstring) - 1)

#define str8_lit_comp(cstring)                                                 \
  {(u8*)(cstring), sizeof(cstring) - 1}

//= rhjr: helper macros

#define print_str8(str8)                                                       \
  printf("%.*s\n", (i32) str8.length, str8.str)

#endif // STRING_H
